using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Routing;
using Microsoft.Extensions.Logging;
using Microsoft.AspNetCore.Authorization;
using Microsoft.EntityFrameworkCore;
using AyaNova.Models;
using AyaNova.Api.ControllerHelpers;
using AyaNova.Biz;
using System.Threading.Tasks;
using System;

namespace AyaNova.Api.Controllers
{

    [ApiController]
    [ApiVersion("8.0")]
    [Route("api/v{version:apiVersion}/global-biz-setting")]
    [Produces("application/json")]
    [Authorize]
    public class GlobalBizSettingsController : ControllerBase
    {
        private readonly AyContext ct;
        private readonly ILogger<GlobalBizSettingsController> log;
        private readonly ApiServerState serverState;



        /// <summary>
        /// ctor
        /// </summary>
        /// <param name="dbcontext"></param>
        /// <param name="logger"></param>
        /// <param name="apiServerState"></param>
        public GlobalBizSettingsController(AyContext dbcontext, ILogger<GlobalBizSettingsController> logger, ApiServerState apiServerState)
        {
            ct = dbcontext;
            log = logger;
            serverState = apiServerState;
        }

        /// <summary>
        /// Get GlobalBizSettings
        /// </summary>      
        /// <returns>Global settings object</returns>
        [HttpGet]
        public async Task<IActionResult> GetGlobalBizSettings()
        {
            if (serverState.IsClosed)
                return StatusCode(503, new ApiErrorResponse(serverState.ApiErrorCode, null, serverState.Reason));

            //Instantiate the business object handler
            GlobalBizSettingsBiz biz = GlobalBizSettingsBiz.GetBiz(ct, HttpContext);

            if (!Authorized.HasReadFullRole(HttpContext.Items, biz.BizType))
                return StatusCode(403, new ApiNotAuthorizedResponse());

            if (!ModelState.IsValid)
                return BadRequest(new ApiErrorResponse(ModelState));

            var o = await biz.GetAsync();
            if (o == null)
                return NotFound(new ApiErrorResponse(ApiErrorCode.NOT_FOUND));

            return Ok(ApiOkResponse.Response(o));
        }


        /// <summary>
        /// PUT Global biz settings   
        /// </summary>       
        /// <param name="updatedObject"></param>
        /// <returns>New concurrency token</returns>      
        [HttpPut]
        public async Task<IActionResult> ReplaceGlobalBizSettings([FromBody] GlobalBizSettings updatedObject)
        {
            if (serverState.IsClosed)
                return StatusCode(503, new ApiErrorResponse(serverState.ApiErrorCode, null, serverState.Reason));

            if (!ModelState.IsValid)
                return BadRequest(new ApiErrorResponse(ModelState));

            //Instantiate the business object handler       
            GlobalBizSettingsBiz biz = GlobalBizSettingsBiz.GetBiz(ct, HttpContext);

            if (!Authorized.HasModifyRole(HttpContext.Items, biz.BizType))
                return StatusCode(403, new ApiNotAuthorizedResponse());

            var o = await biz.PutAsync(updatedObject);//In future may need to return entire object, for now just concurrency token 
            if (o == null)
                return StatusCode(409, new ApiErrorResponse(biz.Errors));
            return Ok(ApiOkResponse.Response(new { Concurrency = o.Concurrency }));
        }

        /// <summary>
        /// Get Client app relevant GlobalBizSettings
        /// </summary>      
        /// <returns>Global settings object</returns>
        [HttpGet("client")]
        public ActionResult GetClientGlobalBizSettings()
        {
            if (serverState.IsClosed)
            {
                //Exception for SuperUser account to handle licensing issues
                if (UserIdFromContext.Id(HttpContext.Items) != 1)
                    return StatusCode(503, new ApiErrorResponse(serverState.ApiErrorCode, null, serverState.Reason));
            }

            var ret = new
            {
                SearchCaseSensitiveOnly = AyaNova.Util.ServerGlobalBizSettings.SearchCaseSensitiveOnly,
                //used to drive UI in case of unlicensed or attention required
                LicenseStatus = AyaNova.Core.License.ActiveKey.Status,
                MaintenanceExpired = AyaNova.Core.License.ActiveKey.MaintenanceExpired,
                ServerDbId = AyaNova.Core.License.ServerDbId,
                Company = AyaNova.Core.License.ActiveKey.RegisteredTo
                // ,
                // TestTSDaysWMS=new TimeSpan(22,10,15,22,33),
                // TestTSHMS=new TimeSpan(5,16,33),
                // TestTS_DHMS=new TimeSpan(5,10,15,33),
                // TestTS_MS=new TimeSpan(0,15,33),
                // TestTS_S=new TimeSpan(0,0,33),
                // TestTS_D=new TimeSpan(22,0,0,0,0)



            };

            return Ok(ApiOkResponse.Response(ret));
        }

    }//eoc
}//ens